// Generated by LiveScript 1.3.1
(function(){
  var glob, fs, promise, _, debug, uid, b64, y, $, processCode, moment, parseTitle, escapeSection, getVerticals, _module;
  glob = require('glob');
  fs = require('fs');
  promise = require('bluebird');
  _ = require('lodash');
  debug = require('debug')(__filename);
  uid = require('uid');
  b64 = require('base64-url');
  y = require('js-yaml');
  $ = require('underscore.string');
  processCode = require('./code/process-code').processCode;
  moment = require('moment');
  parseTitle = function(title, data){
    var matches, format, values, exercises, ref$, ref1$, graded, week, start;
    matches = /[^\{]*\{([^\}]*)\}/.exec(title);
    if (matches) {
      debug(matches[1]);
      values = matches[1].split(',');
      exercises = _.reject(values, function(it){
        return (/W(\d+)/.exec(it)) != null;
      });
      if (((ref$ = data.grading) != null ? ref$.GRADER : void 8) != null) {
        format = (ref1$ = _.first(_.filter(data.grading.GRADER, function(it){
          return it.short_label === exercises[0];
        }))) != null ? ref1$.type : void 8;
      }
      graded = format != null;
      week = _.compact(_.map(values, function(it){
        var m;
        m = /W(\d+)/.exec(it);
        if (m) {
          return m[1];
        } else {
          return null;
        }
      }));
      title = title.replace(/\s*\{[^\}]*\}/, '');
      start = week[0];
      return {
        graded: graded,
        start: start,
        title: title,
        format: format
      };
    }
    return {
      graded: false,
      title: title
    };
  };
  promise.promisifyAll(fs);
  escapeSection = function(d, name){
    var ref$;
    if (((ref$ = d.code) != null ? ref$[name] : void 8) != null) {
      return d.code[name] = _.escape(d.code[name]);
    }
  };
  getVerticals = function(data){
    return promise.map(data.sections, function(d){
      d.urlName = uid(8);
      return processCode(d).then(function(d){
        if (d.code != null) {
          d.code.lang = d.lang;
          d.grader_payload = {
            payload: b64.encode(JSON.stringify(d.code))
          };
          d.grader_payload = JSON.stringify(d.grader_payload);
          escapeSection(d, 'base');
          escapeSection(d, 'solution');
        }
        return d;
      });
    });
  };
  _module = function(){
    var condense;
    condense = function(directory, sourceDir, config){
      var metadata, files, promised_files, res$, i$, len$, f;
      metadata = y.safeLoad(fs.readFileSync(config, 'utf-8'));
      metadata.course.origDir = sourceDir;
      metadata.course.urlName = metadata.course.year + "-" + metadata.course.season;
      metadata.course.displayName = metadata.course.name;
      metadata.course.name = $.slugify(metadata.course.number);
      metadata.organization.displayName = metadata.organization.name;
      metadata.organization.name = $.slugify(metadata.organization.name);
      files = glob.sync(directory + "/**/*.json");
      res$ = [];
      for (i$ = 0, len$ = files.length; i$ < len$; ++i$) {
        f = files[i$];
        res$.push(fs.readFileAsync(f, 'utf-8'));
      }
      promised_files = res$;
      return promise.all(promised_files).map(function(it){
        var data, level, matches;
        data = JSON.parse(it);
        level = data.progress.current.level;
        matches = /(\d)+.?(\d)*/.exec(level);
        if (matches) {
          return getVerticals(data).then(function(verticals){
            var sequential, ref$, graded, title, start, format;
            sequential = {
              chapter: parseInt(matches[1]),
              title: data.progress.current.title,
              verticals: verticals
            };
            if (matches[2] != null) {
              sequential.section = parseInt(matches[2]);
            }
            sequential.section == null && (sequential.section = 0);
            ref$ = parseTitle(sequential.title, metadata), graded = ref$.graded, title = ref$.title, start = ref$.start, format = ref$.format;
            sequential.title = title;
            if (start != null) {
              sequential.start = moment(metadata.course.start).add(start, 'week').format("YYYY MM DD");
            }
            if (format != null) {
              sequential.format = format;
            }
            sequential.graded = graded;
            sequential.displayName = sequential.title;
            sequential.name = $.slugify(sequential.displayName);
            sequential.urlName = sequential.name + ("-" + uid(8));
            if (start != null) {
              debug(sequential);
            }
            return sequential;
          });
        } else {
          return undefined;
        }
      }).then(function(it){
        var grouped, res$, k, v, i$, len$, ref$, ref1$, d;
        grouped = _.groupBy(it, 'chapter');
        res$ = [];
        for (k in grouped) {
          v = grouped[k];
          res$.push(v);
        }
        grouped = res$;
        res$ = [];
        for (i$ = 0, len$ = grouped.length; i$ < len$; ++i$) {
          v = grouped[i$];
          res$.push(_.sortBy(v, 'section'));
        }
        grouped = res$;
        _.map(_.filter(_.flatten(grouped), function(it){
          return it.graded;
        }), function(it){
          it.exercises = _.countBy(it.verticals, function(it){
            return it.exercise === true;
          })['true'] || 0;
          return it;
        });
        metadata.exercises = _.mapValues(_.groupBy(_.filter(_.flatten(grouped), function(it){
          return it.graded;
        }), function(it){
          return it.format;
        }), function(it){
          return _.reduce(it, function(sum, n){
            return sum + n.exercises;
          }, 0);
        });
        if (((ref$ = metadata.grading) != null ? ref$.GRADER : void 8) != null) {
          for (i$ = 0, len$ = (ref1$ = metadata.grading.GRADER).length; i$ < len$; ++i$) {
            d = ref1$[i$];
            if (in$(d.type, _.keys(metadata.exercises))) {
              d.min_count = metadata.exercises[d.type];
            } else {
              d.min_count = 0;
              d.drop_count = 0;
            }
          }
        }
        grouped = _.map(grouped, function(it){
          it.displayName = it[0].displayName;
          it.start = it[0].start;
          it.urlName = it[0].urlName + "-" + uid(8);
          return it;
        });
        debug("All data gathered into a single structure");
        return _.extend(metadata, {
          chapters: grouped
        });
      });
    };
    return {
      condense: condense
    };
  };
  module.exports = _module();
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
}).call(this);
